/**
* router API generated from router.yang
*
* NOTE: This file is auto generated by polycube-codegen
* https://github.com/polycube-network/polycube-codegen
*/


/* Do not edit this file manually */

/*
* RouterApiImpl.h
*
*
*/

#pragma once


#include <memory>
#include <map>
#include <mutex>
#include "../Router.h"

#include "ArpTableJsonObject.h"
#include "PortsJsonObject.h"
#include "PortsSecondaryipJsonObject.h"
#include "RouteJsonObject.h"
#include "RouterJsonObject.h"
#include <vector>

namespace polycube {
namespace service {
namespace api {

using namespace polycube::service::model;

namespace RouterApiImpl {
  void create_router_arp_table_by_id(const std::string &name, const std::string &address, const ArpTableJsonObject &value);
  void create_router_arp_table_list_by_id(const std::string &name, const std::vector<ArpTableJsonObject> &value);
  void create_router_by_id(const std::string &name, const RouterJsonObject &value);
  void create_router_ports_by_id(const std::string &name, const std::string &portsName, const PortsJsonObject &value);
  void create_router_ports_list_by_id(const std::string &name, const std::vector<PortsJsonObject> &value);
  void create_router_ports_secondaryip_by_id(const std::string &name, const std::string &portsName, const std::string &ip, const PortsSecondaryipJsonObject &value);
  void create_router_ports_secondaryip_list_by_id(const std::string &name, const std::string &portsName, const std::vector<PortsSecondaryipJsonObject> &value);
  void create_router_route_by_id(const std::string &name, const std::string &network, const std::string &nexthop, const RouteJsonObject &value);
  void create_router_route_list_by_id(const std::string &name, const std::vector<RouteJsonObject> &value);
  void delete_router_arp_table_by_id(const std::string &name, const std::string &address);
  void delete_router_arp_table_list_by_id(const std::string &name);
  void delete_router_by_id(const std::string &name);
  void delete_router_ports_by_id(const std::string &name, const std::string &portsName);
  void delete_router_ports_list_by_id(const std::string &name);
  void delete_router_ports_secondaryip_by_id(const std::string &name, const std::string &portsName, const std::string &ip);
  void delete_router_ports_secondaryip_list_by_id(const std::string &name, const std::string &portsName);
  void delete_router_route_by_id(const std::string &name, const std::string &network, const std::string &nexthop);
  void delete_router_route_list_by_id(const std::string &name);
  ArpTableJsonObject read_router_arp_table_by_id(const std::string &name, const std::string &address);
  std::string read_router_arp_table_interface_by_id(const std::string &name, const std::string &address);
  std::vector<ArpTableJsonObject> read_router_arp_table_list_by_id(const std::string &name);
  std::string read_router_arp_table_mac_by_id(const std::string &name, const std::string &address);
  RouterJsonObject read_router_by_id(const std::string &name);
  std::vector<RouterJsonObject> read_router_list_by_id();
  PortsJsonObject read_router_ports_by_id(const std::string &name, const std::string &portsName);
  std::string read_router_ports_ip_by_id(const std::string &name, const std::string &portsName);
  std::vector<PortsJsonObject> read_router_ports_list_by_id(const std::string &name);
  std::string read_router_ports_mac_by_id(const std::string &name, const std::string &portsName);
  PortsSecondaryipJsonObject read_router_ports_secondaryip_by_id(const std::string &name, const std::string &portsName, const std::string &ip);
  std::vector<PortsSecondaryipJsonObject> read_router_ports_secondaryip_list_by_id(const std::string &name, const std::string &portsName);
  RouteJsonObject read_router_route_by_id(const std::string &name, const std::string &network, const std::string &nexthop);
  std::string read_router_route_interface_by_id(const std::string &name, const std::string &network, const std::string &nexthop);
  std::vector<RouteJsonObject> read_router_route_list_by_id(const std::string &name);
  uint32_t read_router_route_pathcost_by_id(const std::string &name, const std::string &network, const std::string &nexthop);
  void replace_router_arp_table_by_id(const std::string &name, const std::string &address, const ArpTableJsonObject &value);
  void replace_router_arp_table_list_by_id(const std::string &name, const std::vector<ArpTableJsonObject> &value);
  void replace_router_by_id(const std::string &name, const RouterJsonObject &value);
  void replace_router_ports_by_id(const std::string &name, const std::string &portsName, const PortsJsonObject &value);
  void replace_router_ports_list_by_id(const std::string &name, const std::vector<PortsJsonObject> &value);
  void replace_router_ports_secondaryip_by_id(const std::string &name, const std::string &portsName, const std::string &ip, const PortsSecondaryipJsonObject &value);
  void replace_router_ports_secondaryip_list_by_id(const std::string &name, const std::string &portsName, const std::vector<PortsSecondaryipJsonObject> &value);
  void replace_router_route_by_id(const std::string &name, const std::string &network, const std::string &nexthop, const RouteJsonObject &value);
  void replace_router_route_list_by_id(const std::string &name, const std::vector<RouteJsonObject> &value);
  void update_router_arp_table_by_id(const std::string &name, const std::string &address, const ArpTableJsonObject &value);
  void update_router_arp_table_interface_by_id(const std::string &name, const std::string &address, const std::string &value);
  void update_router_arp_table_list_by_id(const std::string &name, const std::vector<ArpTableJsonObject> &value);
  void update_router_arp_table_mac_by_id(const std::string &name, const std::string &address, const std::string &value);
  void update_router_by_id(const std::string &name, const RouterJsonObject &value);
  void update_router_list_by_id(const std::vector<RouterJsonObject> &value);
  void update_router_ports_by_id(const std::string &name, const std::string &portsName, const PortsJsonObject &value);
  void update_router_ports_ip_by_id(const std::string &name, const std::string &portsName, const std::string &value);
  void update_router_ports_list_by_id(const std::string &name, const std::vector<PortsJsonObject> &value);
  void update_router_ports_mac_by_id(const std::string &name, const std::string &portsName, const std::string &value);
  void update_router_ports_secondaryip_by_id(const std::string &name, const std::string &portsName, const std::string &ip, const PortsSecondaryipJsonObject &value);
  void update_router_ports_secondaryip_list_by_id(const std::string &name, const std::string &portsName, const std::vector<PortsSecondaryipJsonObject> &value);
  void update_router_route_by_id(const std::string &name, const std::string &network, const std::string &nexthop, const RouteJsonObject &value);
  void update_router_route_list_by_id(const std::string &name, const std::vector<RouteJsonObject> &value);
  void update_router_route_pathcost_by_id(const std::string &name, const std::string &network, const std::string &nexthop, const uint32_t &value);

  /* help related */
  std::vector<nlohmann::fifo_map<std::string, std::string>> read_router_arp_table_list_by_id_get_list(const std::string &name);
  std::vector<nlohmann::fifo_map<std::string, std::string>> read_router_list_by_id_get_list();
  std::vector<nlohmann::fifo_map<std::string, std::string>> read_router_ports_list_by_id_get_list(const std::string &name);
  std::vector<nlohmann::fifo_map<std::string, std::string>> read_router_ports_secondaryip_list_by_id_get_list(const std::string &name, const std::string &portsName);
  std::vector<nlohmann::fifo_map<std::string, std::string>> read_router_route_list_by_id_get_list(const std::string &name);

}
}
}
}

